
#ifdef HAVE_HEXHUB_CPP_UTILS

#include <windows.h>
#include "HeXHuB.h"

#define GF(fnname) HexHubFunctions::GetFunction(fnname)
#define TestPointer(ptr) if (ptr == 0) return false

lpfnGetFunction               HexHubFunctions::GetFunction             = 0;
lpfnSendTo                    HexHubFunctions::SendTo                  = 0;
lpfnSendToAll                 HexHubFunctions::SendToAll               = 0;
lpfnRegisterCommand           HexHubFunctions::RegisterCommand         = 0;
lpfnRegisterHelpString        HexHubFunctions::RegisterHelpString      = 0;
lpfnIdFromNick                HexHubFunctions::IdFromNick              = 0;
lpfnGetUserCount              HexHubFunctions::GetUserCount            = 0;
lpfnGetUserIds                HexHubFunctions::GetUserIds              = 0;
lpfnClientNickFromId          HexHubFunctions::ClientNickFromId        = 0; 
lpfnGetVersion                HexHubFunctions::GetVersion              = 0;
lpfnSendNotificationMessage   HexHubFunctions::SendNotificationMessage = 0;
lpfnNickFromId                HexHubFunctions::NickFromId              = 0;
lpfnGetInfo                   HexHubFunctions::GetInfo                 = 0;
lpfnGetFullInfo               HexHubFunctions::GetFullInfo             = 0;
lpfnSetInfo                   HexHubFunctions::SetInfo                 = 0;
lpfnGetDescription            HexHubFunctions::GetDescription          = 0;
lpfnSetDescription            HexHubFunctions::SetDescription          = 0;
lpfnGetTag                    HexHubFunctions::GetTag                  = 0;
lpfnSetTag                    HexHubFunctions::SetTag                  = 0;
lpfnGetConnection             HexHubFunctions::GetConnection           = 0;
lpfnSetConnection             HexHubFunctions::SetConnection           = 0;
lpfnGetMail                   HexHubFunctions::GetMail                 = 0;
lpfnSetMail                   HexHubFunctions::SetMail                 = 0;
lpfnGetShareString            HexHubFunctions::GetShareString          = 0;
lpfnSetShareString            HexHubFunctions::SetShareString          = 0;
lpfnGetIP                     HexHubFunctions::GetIP                   = 0;
lpfnGetIPString               HexHubFunctions::GetIPString             = 0;
lpfnGetISPName                HexHubFunctions::GetISPName              = 0;
lpfnGetOpStatus               HexHubFunctions::GetOpStatus             = 0;
lpfnSetOpStatus               HexHubFunctions::SetOpStatus             = 0;
lpfnGetLanguage               HexHubFunctions::GetLanguage             = 0;
lpfnSetLanguage               HexHubFunctions::SetLanguage             = 0;
lpfnGetMode                   HexHubFunctions::GetMode                 = 0;
lpfnSetMode                   HexHubFunctions::SetMode                 = 0;
lpfnModeTransform             HexHubFunctions::ModeTransform           = 0;
lpfnGetMastersCount           HexHubFunctions::GetMastersCount         = 0;
lpfnGetMastersIds             HexHubFunctions::GetMastersIds           = 0;
lpfnGetIpCacheInfo            HexHubFunctions::GetIpCacheInfo          = 0;
lpfnSetIpCacheInfo            HexHubFunctions::SetIpCacheInfo          = 0;
lpfnGetAccessLevel            HexHubFunctions::GetAccessLevel          = 0;
lpfnSetAccessLevel            HexHubFunctions::SetAccessLevel          = 0;
lpfnGetRights                 HexHubFunctions::GetRights               = 0;
lpfnSetRights                 HexHubFunctions::SetRights               = 0;
lpfnGetProfileId              HexHubFunctions::GetProfileId            = 0;
lpfnGetAccountId              HexHubFunctions::GetAccountId            = 0;
lpfnCreateAccount             HexHubFunctions::CreateAccount           = 0;
lpfnDeleteAccount             HexHubFunctions::DeleteAccount           = 0;
lpfnMoveAccount               HexHubFunctions::MoveAccount             = 0;
lpfnSetProfile                HexHubFunctions::SetProfile              = 0;
lpfnGetProfile                HexHubFunctions::GetProfile              = 0;
lpfnGetNextProfile            HexHubFunctions::GetNextProfile          = 0;
lpfnGetAccount                HexHubFunctions::GetAccount              = 0;
lpfnSetAccount                HexHubFunctions::SetAccount              = 0;
lpfnGetNextAccount            HexHubFunctions::GetNextAccount          = 0;
lpfnAllocUserData             HexHubFunctions::AllocUserData           = 0;
lpfnFreeUserData              HexHubFunctions::FreeUserData            = 0;
lpfnGetUserData               HexHubFunctions::GetUserData             = 0;
lpfnSetUserData               HexHubFunctions::SetUserData             = 0;
lpfnUnregisterCommand         HexHubFunctions::UnregisterCommand       = 0;
lpfnUnregisterHelpString      HexHubFunctions::UnregisterHelpString    = 0;
lpfnUnregisterUserCommand     HexHubFunctions::UnregisterUserCommand   = 0;
lpfnRegisterUserCommand       HexHubFunctions::RegisterUserCommand     = 0;
lpfnRegisterChatFilter        HexHubFunctions::RegisterChatFilter      = 0;
lpfnUnregisterChatFilter      HexHubFunctions::UnregisterChatFilter    = 0;
lpfnRegisterBot               HexHubFunctions::RegisterBot             = 0;
lpfnUnregisterBot             HexHubFunctions::UnregisterBot           = 0;
lpfnCallHubCommand            HexHubFunctions::CallHubCommand          = 0;
lpfnProcessUserTraffic        HexHubFunctions::ProcessUserTraffic      = 0;
lpfnDisableOutputToUser       HexHubFunctions::DisableOutputToUser     = 0;
lpfnAcceptUser                HexHubFunctions::AcceptUser              = 0;
lpfnGetTopic                  HexHubFunctions::GetTopic                = 0;
lpfnSetTopic                  HexHubFunctions::SetTopic                = 0;
lpfnGetMOTD                   HexHubFunctions::GetMOTD                 = 0; 
lpfnSetMOTD                   HexHubFunctions::SetMOTD                 = 0;
lpfnGetHubUptime              HexHubFunctions::GetHubUptime            = 0;
lpfnGetHublistEntry           HexHubFunctions::GetHublistEntry         = 0;
lpfnRegisterBotEx             HexHubFunctions::RegisterBotEx           = 0;
#if (HEXHUB_VERSION >= 320)
lpfnDisconnectUser            HexHubFunctions::DisconnectUser          = 0;
#endif


bool HexHubFunctions::Init(lpfnGetFunction GetFunction) {
	HexHubFunctions::GetFunction             = GetFunction;
	HexHubFunctions::AcceptUser              = reinterpret_cast<lpfnAcceptUser>              (GF("AcceptUser"));
	HexHubFunctions::AllocUserData           = reinterpret_cast<lpfnAllocUserData>           (GF("AllocUserData"));
	HexHubFunctions::CallHubCommand          = reinterpret_cast<lpfnCallHubCommand>          (GF("CallHubCommand"));
	HexHubFunctions::ClientNickFromId        = reinterpret_cast<lpfnClientNickFromId>        (GF("ClientNickFromId"));
	HexHubFunctions::CreateAccount           = reinterpret_cast<lpfnCreateAccount>           (GF("CreateAccount"));
	HexHubFunctions::DeleteAccount           = reinterpret_cast<lpfnDeleteAccount>           (GF("DeleteAccount"));
	HexHubFunctions::DisableOutputToUser     = reinterpret_cast<lpfnDisableOutputToUser>     (GF("DisableOutputToUser"));
	HexHubFunctions::FreeUserData            = reinterpret_cast<lpfnFreeUserData>            (GF("FreeUserData"));
	HexHubFunctions::GetAccessLevel          = reinterpret_cast<lpfnGetAccessLevel>          (GF("GetAccessLevel"));
	HexHubFunctions::GetAccount              = reinterpret_cast<lpfnGetAccount>              (GF("GetAccount"));
	HexHubFunctions::GetAccountId            = reinterpret_cast<lpfnGetAccountId>            (GF("GetAccountId"));
	HexHubFunctions::GetConnection           = reinterpret_cast<lpfnGetConnection>           (GF("GetConnection"));
	HexHubFunctions::GetDescription          = reinterpret_cast<lpfnGetDescription>          (GF("GetDescription"));
	HexHubFunctions::GetFullInfo             = reinterpret_cast<lpfnGetFullInfo>             (GF("GetFullInfo"));
	HexHubFunctions::GetHublistEntry         = reinterpret_cast<lpfnGetHublistEntry>         (GF("GetHublistEntry"));
	HexHubFunctions::GetHubUptime            = reinterpret_cast<lpfnGetHubUptime>            (GF("GetHubUptime"));
	HexHubFunctions::GetInfo                 = reinterpret_cast<lpfnGetInfo>                 (GF("GetInfo"));
	HexHubFunctions::GetIP                   = reinterpret_cast<lpfnGetIP>                   (GF("GetIP"));
	HexHubFunctions::GetIpCacheInfo          = reinterpret_cast<lpfnGetIpCacheInfo>          (GF("GetIpCacheInfo"));
	HexHubFunctions::GetIPString             = reinterpret_cast<lpfnGetIPString>             (GF("GetIPString"));
	HexHubFunctions::GetISPName              = reinterpret_cast<lpfnGetISPName>              (GF("GetISPName"));
	HexHubFunctions::GetLanguage             = reinterpret_cast<lpfnGetLanguage>             (GF("GetLanguage"));
	HexHubFunctions::GetMail                 = reinterpret_cast<lpfnGetMail>                 (GF("GetMail"));
	HexHubFunctions::GetMastersIds           = reinterpret_cast<lpfnGetMastersIds>           (GF("GetMastersIds"));
	HexHubFunctions::GetMastersCount         = reinterpret_cast<lpfnGetMastersCount>         (GF("GetMastersCount"));
	HexHubFunctions::GetMode                 = reinterpret_cast<lpfnGetMode>                 (GF("GetMode"));
	HexHubFunctions::GetMOTD                 = reinterpret_cast<lpfnGetMOTD>                 (GF("GetMOTD"));
	HexHubFunctions::GetNextAccount          = reinterpret_cast<lpfnGetNextAccount>          (GF("GetNextAccount"));
	HexHubFunctions::GetNextProfile          = reinterpret_cast<lpfnGetNextProfile>          (GF("GetNextProfile"));
	HexHubFunctions::GetOpStatus             = reinterpret_cast<lpfnGetOpStatus>             (GF("GetOpStatus"));
	HexHubFunctions::GetProfile              = reinterpret_cast<lpfnGetProfile>              (GF("GetProfile"));
	HexHubFunctions::GetProfileId            = reinterpret_cast<lpfnGetProfileId>            (GF("GetProfileId"));
	HexHubFunctions::GetRights               = reinterpret_cast<lpfnGetRights>               (GF("GetRights"));
	HexHubFunctions::GetShareString          = reinterpret_cast<lpfnGetShareString>          (GF("GetShareString"));
	HexHubFunctions::GetTag                  = reinterpret_cast<lpfnGetTag>                  (GF("GetTag"));
	HexHubFunctions::GetTopic                = reinterpret_cast<lpfnGetTopic>                (GF("GetTopic"));
	HexHubFunctions::GetUserCount            = reinterpret_cast<lpfnGetUserCount>            (GF("GetUserCount"));
	HexHubFunctions::GetUserData             = reinterpret_cast<lpfnGetUserData>             (GF("GetUserData"));
	HexHubFunctions::GetUserIds              = reinterpret_cast<lpfnGetUserIds>              (GF("GetUserIds"));
	HexHubFunctions::GetVersion              = reinterpret_cast<lpfnGetVersion>              (GF("GetVersion"));
	HexHubFunctions::IdFromNick              = reinterpret_cast<lpfnIdFromNick>              (GF("IdFromNick"));
	HexHubFunctions::ModeTransform           = reinterpret_cast<lpfnModeTransform>           (GF("ModeTransform"));
	HexHubFunctions::MoveAccount             = reinterpret_cast<lpfnMoveAccount>             (GF("MoveAccount"));
	HexHubFunctions::NickFromId              = reinterpret_cast<lpfnNickFromId>              (GF("NickFromId"));
	HexHubFunctions::ProcessUserTraffic      = reinterpret_cast<lpfnProcessUserTraffic>      (GF("ProcessUserTraffic"));
	HexHubFunctions::RegisterBotEx           = reinterpret_cast<lpfnRegisterBotEx>           (GF("RegisterBotEx"));
	HexHubFunctions::RegisterBot             = reinterpret_cast<lpfnRegisterBot>             (GF("RegisterBot"));
	HexHubFunctions::RegisterChatFilter      = reinterpret_cast<lpfnRegisterChatFilter>      (GF("RegisterChatFilter"));
	HexHubFunctions::RegisterCommand         = reinterpret_cast<lpfnRegisterCommand>         (GF("RegisterCommand"));
	HexHubFunctions::RegisterHelpString      = reinterpret_cast<lpfnRegisterHelpString>      (GF("RegisterHelpString"));
	HexHubFunctions::RegisterUserCommand     = reinterpret_cast<lpfnRegisterUserCommand>     (GF("RegisterUserCommand"));
	HexHubFunctions::SendNotificationMessage = reinterpret_cast<lpfnSendNotificationMessage> (GF("SendNotificationMessage"));
	HexHubFunctions::SendTo                  = reinterpret_cast<lpfnSendTo>                  (GF("SendTo"));
	HexHubFunctions::SendToAll               = reinterpret_cast<lpfnSendToAll>               (GF("SendToAll"));
	HexHubFunctions::SetAccessLevel          = reinterpret_cast<lpfnSetAccessLevel>          (GF("SetAccessLevel"));
	HexHubFunctions::SetAccount              = reinterpret_cast<lpfnSetAccount>              (GF("SetAccount"));
	HexHubFunctions::SetConnection           = reinterpret_cast<lpfnSetConnection>           (GF("SetConnection"));
	HexHubFunctions::SetDescription          = reinterpret_cast<lpfnSetDescription>          (GF("SetDescription"));
	HexHubFunctions::SetInfo                 = reinterpret_cast<lpfnSetInfo>                 (GF("SetInfo"));
	HexHubFunctions::SetIpCacheInfo          = reinterpret_cast<lpfnSetIpCacheInfo>          (GF("SetIpCacheInfo"));
	HexHubFunctions::SetLanguage             = reinterpret_cast<lpfnSetLanguage>             (GF("SetLanguage"));
	HexHubFunctions::SetMail                 = reinterpret_cast<lpfnSetMail>                 (GF("SetMail"));
	HexHubFunctions::SetMode                 = reinterpret_cast<lpfnSetMode>                 (GF("SetMode"));
	HexHubFunctions::SetMOTD                 = reinterpret_cast<lpfnSetMOTD>                 (GF("SetMOTD"));
	HexHubFunctions::SetOpStatus             = reinterpret_cast<lpfnSetOpStatus>             (GF("SetOpStatus"));
	HexHubFunctions::SetProfile              = reinterpret_cast<lpfnSetProfile>              (GF("SetProfile"));
	HexHubFunctions::SetRights               = reinterpret_cast<lpfnSetRights>               (GF("SetRights"));
	HexHubFunctions::SetShareString          = reinterpret_cast<lpfnSetShareString>          (GF("SetShareString"));
	HexHubFunctions::SetTag                  = reinterpret_cast<lpfnSetTag>                  (GF("SetTag"));
	HexHubFunctions::SetTopic                = reinterpret_cast<lpfnSetTopic>                (GF("SetTopic"));
	HexHubFunctions::SetUserData             = reinterpret_cast<lpfnSetUserData>             (GF("SetUserData"));
	HexHubFunctions::UnregisterBot           = reinterpret_cast<lpfnUnregisterBot>           (GF("UnregisterBot"));
	HexHubFunctions::UnregisterChatFilter    = reinterpret_cast<lpfnUnregisterChatFilter>    (GF("UnregisterChatFilter"));
	HexHubFunctions::UnregisterCommand       = reinterpret_cast<lpfnUnregisterCommand>       (GF("UnregisterCommand"));
	HexHubFunctions::UnregisterHelpString    = reinterpret_cast<lpfnUnregisterHelpString>    (GF("UnregisterHelpString"));
	HexHubFunctions::UnregisterUserCommand   = reinterpret_cast<lpfnUnregisterUserCommand>   (GF("UnregisterUserCommand"));

#if (HEXHUB_VERSION >= 320)
	HexHubFunctions::DisconnectUser          = reinterpret_cast<lpfnDisconnectUser>          (GF("DisconnectUser"));
#endif

	TestPointer(HexHubFunctions::AcceptUser);
	TestPointer(HexHubFunctions::AllocUserData);
	TestPointer(HexHubFunctions::CallHubCommand);
	TestPointer(HexHubFunctions::ClientNickFromId);
	TestPointer(HexHubFunctions::CreateAccount);
	TestPointer(HexHubFunctions::DeleteAccount);
	TestPointer(HexHubFunctions::DisableOutputToUser);
	TestPointer(HexHubFunctions::FreeUserData);
	TestPointer(HexHubFunctions::GetAccessLevel);
	TestPointer(HexHubFunctions::GetAccount);
	TestPointer(HexHubFunctions::GetAccountId);
	TestPointer(HexHubFunctions::GetConnection);
	TestPointer(HexHubFunctions::GetDescription);
	TestPointer(HexHubFunctions::GetFullInfo);
	TestPointer(HexHubFunctions::GetHublistEntry);
	TestPointer(HexHubFunctions::GetHubUptime);
	TestPointer(HexHubFunctions::GetInfo);
	TestPointer(HexHubFunctions::GetIP);
	TestPointer(HexHubFunctions::GetIpCacheInfo);
	TestPointer(HexHubFunctions::GetIPString);
	TestPointer(HexHubFunctions::GetISPName);
	TestPointer(HexHubFunctions::GetLanguage);
	TestPointer(HexHubFunctions::GetMail);
	TestPointer(HexHubFunctions::GetMastersIds);
	TestPointer(HexHubFunctions::GetMastersCount);
	TestPointer(HexHubFunctions::GetMode);
	TestPointer(HexHubFunctions::GetMOTD);
	TestPointer(HexHubFunctions::GetNextAccount);
	TestPointer(HexHubFunctions::GetNextProfile);
	TestPointer(HexHubFunctions::GetOpStatus);
	TestPointer(HexHubFunctions::GetProfile);
	TestPointer(HexHubFunctions::GetProfileId);
	TestPointer(HexHubFunctions::GetRights);
	TestPointer(HexHubFunctions::GetShareString);
	TestPointer(HexHubFunctions::GetTag);
	TestPointer(HexHubFunctions::GetTopic);
	TestPointer(HexHubFunctions::GetUserCount);
	TestPointer(HexHubFunctions::GetUserData);
	TestPointer(HexHubFunctions::GetUserIds);
	TestPointer(HexHubFunctions::GetVersion);
	TestPointer(HexHubFunctions::IdFromNick);
	TestPointer(HexHubFunctions::ModeTransform);
	TestPointer(HexHubFunctions::MoveAccount);
	TestPointer(HexHubFunctions::NickFromId);
	TestPointer(HexHubFunctions::ProcessUserTraffic);
	TestPointer(HexHubFunctions::RegisterBot);
	TestPointer(HexHubFunctions::RegisterBotEx);
	TestPointer(HexHubFunctions::RegisterChatFilter);
	TestPointer(HexHubFunctions::RegisterCommand);
	TestPointer(HexHubFunctions::RegisterHelpString);
	TestPointer(HexHubFunctions::RegisterUserCommand);
	TestPointer(HexHubFunctions::SendNotificationMessage);
	TestPointer(HexHubFunctions::SendTo);
	TestPointer(HexHubFunctions::SendToAll);
	TestPointer(HexHubFunctions::SetAccessLevel);
	TestPointer(HexHubFunctions::SetAccount);
	TestPointer(HexHubFunctions::SetConnection);
	TestPointer(HexHubFunctions::SetDescription);
	TestPointer(HexHubFunctions::SetInfo);
	TestPointer(HexHubFunctions::SetIpCacheInfo);
	TestPointer(HexHubFunctions::SetLanguage);
	TestPointer(HexHubFunctions::SetMail);
	TestPointer(HexHubFunctions::SetMode);
	TestPointer(HexHubFunctions::SetMOTD);
	TestPointer(HexHubFunctions::SetOpStatus);
	TestPointer(HexHubFunctions::SetProfile);
	TestPointer(HexHubFunctions::SetRights);
	TestPointer(HexHubFunctions::SetShareString);
	TestPointer(HexHubFunctions::SetTag);
	TestPointer(HexHubFunctions::SetTopic);
	TestPointer(HexHubFunctions::SetUserData);
	TestPointer(HexHubFunctions::UnregisterBot);
	TestPointer(HexHubFunctions::UnregisterChatFilter);
	TestPointer(HexHubFunctions::UnregisterCommand);
	TestPointer(HexHubFunctions::UnregisterHelpString);
	TestPointer(HexHubFunctions::UnregisterUserCommand);
#if (HEXHUB_VERSION >= 320)
	TestPointer(HexHubFunctions::DisconnectUser);
#endif
	return true;
}

#endif // HAVE_HEXHUB_CPP_UTILS

